/* $Id: bow.java,v 1.12 2012/02/04 23:30:27 mit Exp $
/* bow.java v0.0 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class bow extends Applet 
    implements Runnable, ActionListener, AdjustmentListener
{
    private Panel PS;
    private Panel PE;
    private Button btGo;
    private Button btStop;
    private Button btP;
    private Button btM;
    private Button btDisp;
    private Scrollbar scrBP;
    private Label lbBP;
    private Thread th;

    static int LEN = 64;
    static int PAR = 40;
    static int HZ = 1;
    static int FLM = 64;
    static double DT = 2.0*Math.PI/FLM;

    boolean Runsw;
    int W;
    int H;
    int H2;
    int DOT = 4;
    int SFT = DOT/2;
    int DOT1 = 2;
    int SFT1 = 1;
    int LOOP;
    int M = 10;
    int DISP;
    double DD;
    double DH;
    double VOL = 1/50.0;
    double BP = 1.0/M;

    Graphics gi;
    Image ig;
    DecimalFormat df1;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

	PS = new Panel();
        PS.setLayout(new GridLayout(2,3,0,0));

        btGo = new Button("GO");
        PS.add(btGo);
        btGo.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

	PS.add(new Label(""));

	scrBP = new Scrollbar(Scrollbar.HORIZONTAL,LEN/8,1,3,LEN/2);
        PS.add(scrBP);
        scrBP.addAdjustmentListener(this);

	lbBP = new Label(": Bowing Point 1/___");
	PS.add(lbBP);

        btDisp = new Button("Disp.__");
        PS.add(btDisp);
        btDisp.addActionListener(this);

	add(PS, "South");

	PE = new Panel();
        PE.setLayout(new GridLayout(4,1,0,0));

	PE.add(new Label(""));
	PE.add(new Label(""));

        btP = new Button("+");
        PE.add(btP);
        btP.addActionListener(this);

        btM = new Button("-");
        PE.add(btM);
        btM.addActionListener(this);

	add(PE, "East");
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	DD = W/(double)(LEN+1); // +1
	DH = H*VOL;

	ig = createImage(W, H);
	gi = ig.getGraphics();

	set_label();
	write_disp();

	if (th == null) {
            th = new Thread(this);
            th.start();
        }
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
	Dimension de = PE.getSize();
        Dimension da = getSize();
        int cw = da.width-de.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void run() {
	while(!Runsw) {
            try {
		LOOP++;
		if (LOOP > FLM)
		    LOOP = 0;

		repaint();
                th.sleep(80);
            } 
            catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
    public void stop() {
        if (th != null) {
            th = null;

	    LOOP = 0;
	}
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btStop)
	    Runsw = true;
        else if (e.getSource() == btGo) {
            Runsw = false;
            th = null;
            start();
        }
	else if (e.getSource() == btP)
	    set_volume(true);
	else if (e.getSource() == btM)
	    set_volume(false);

	else if (e.getSource() == btDisp)
	    set_disp();
    }
    public void set_volume(boolean sw) {
	double by = Math.sqrt(2);

	VOL = sw ? VOL*by : VOL/by;
	DH = H*VOL;
    }
    public void set_disp() {
	DISP++;
	if (DISP > 5)
	    DISP = 0;

	write_disp();
    }
    public void write_disp() {
	btDisp.setLabel("Disp. "+DISP);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == scrBP) {
	    BP = scrBP.getValue()/(double)LEN;
	    M = (int)(1.0/BP);

	    set_label();

	    repaint();
	}
    }
    public void set_label() {
	lbBP.setText(": Bowing Point 1/"+dform(1/BP));
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
        gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	disp_line(gi);

	int dx, dx1;
	double[] val = new double[M+2];
	for (int i = 0; i <= LEN; i++) {
	    dx = (int)(DD*i+SFT);
	    dx1 = (int)(DD*i+SFT1);

	    val = bowing(i);

	    if (DISP > 1 & DISP < 4 | DISP == 5) {
		gi.setColor(Color.gray);
		for (int j = 0; j < M; j++) {
		    gi.fillOval(dx1, (int)(H2-DH*val[j]), DOT1, DOT1);
		}
	    }
	    if (DISP > 0 & DISP < 5) {
		gi.setColor(Color.lightGray);
		gi.fillOval(dx, (int)(H2-DH*val[M]), DOT, DOT);
	    }

	    if (DISP < 3) {
		gi.setColor(Color.green);
		gi.fillOval(dx, (int)(H2-DH*val[M+1]), DOT, DOT);
	    }
	}
    }
    public double[] bowing(int x) {
	double mp, ms, mb, te, p, m, val = 0;
	double[] val0 = new double[M+2];

	for (int i = 0; i < PAR; i++) {  // 1~
	    p = i+1;
	    mp = p*Math.PI;
	    mb = mp*BP;
	    te = p*DT*LOOP*HZ;
	    ms = Math.sin(mp*x/LEN)/(p*p);

	    for (int j = 0; j < M; j++) {
		m = j+1;
		val0[j] += ms*Math.sin((2*m-1)*mb-te); // left 
	    }
	    val0[M] += ms*M*Math.sin(mp*BP+te); // right

	    for (int j = 0; j < M; j++) {
		m = j+1;
		val += Math.sin((2*m-1)*mb-te);
	    }
	    val0[M+1] += ms*(M*Math.sin(mp*BP+te)+val);
	}

	return val0;
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2+SFT, W, H2+SFT);
    }
}